<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfIdentifierVehicleResult ArrayType
 * @subpackage Arrays
 */
class ArrayOfIdentifierVehicleResult extends AbstractStructArrayBase
{
    /**
     * The IdentifierVehicleResult
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\IdentifierVehicleResult[]
     */
    public $IdentifierVehicleResult;
    /**
     * Constructor method for ArrayOfIdentifierVehicleResult
     * @uses ArrayOfIdentifierVehicleResult::setIdentifierVehicleResult()
     * @param \StructType\IdentifierVehicleResult[] $identifierVehicleResult
     */
    public function __construct(array $identifierVehicleResult = array())
    {
        $this
            ->setIdentifierVehicleResult($identifierVehicleResult);
    }
    /**
     * Get IdentifierVehicleResult value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\IdentifierVehicleResult[]|null
     */
    public function getIdentifierVehicleResult()
    {
        return isset($this->IdentifierVehicleResult) ? $this->IdentifierVehicleResult : null;
    }
    /**
     * This method is responsible for validating the values passed to the setIdentifierVehicleResult method
     * This method is willingly generated in order to preserve the one-line inline validation within the setIdentifierVehicleResult method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateIdentifierVehicleResultForArrayConstraintsFromSetIdentifierVehicleResult(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfIdentifierVehicleResultIdentifierVehicleResultItem) {
            // validation for constraint: itemType
            if (!$arrayOfIdentifierVehicleResultIdentifierVehicleResultItem instanceof \StructType\IdentifierVehicleResult) {
                $invalidValues[] = is_object($arrayOfIdentifierVehicleResultIdentifierVehicleResultItem) ? get_class($arrayOfIdentifierVehicleResultIdentifierVehicleResultItem) : sprintf('%s(%s)', gettype($arrayOfIdentifierVehicleResultIdentifierVehicleResultItem), var_export($arrayOfIdentifierVehicleResultIdentifierVehicleResultItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The IdentifierVehicleResult property can only contain items of type \StructType\IdentifierVehicleResult, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set IdentifierVehicleResult value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\IdentifierVehicleResult[] $identifierVehicleResult
     * @return \ArrayType\ArrayOfIdentifierVehicleResult
     */
    public function setIdentifierVehicleResult(array $identifierVehicleResult = array())
    {
        // validation for constraint: array
        if ('' !== ($identifierVehicleResultArrayErrorMessage = self::validateIdentifierVehicleResultForArrayConstraintsFromSetIdentifierVehicleResult($identifierVehicleResult))) {
            throw new \InvalidArgumentException($identifierVehicleResultArrayErrorMessage, __LINE__);
        }
        if (is_null($identifierVehicleResult) || (is_array($identifierVehicleResult) && empty($identifierVehicleResult))) {
            unset($this->IdentifierVehicleResult);
        } else {
            $this->IdentifierVehicleResult = $identifierVehicleResult;
        }
        return $this;
    }
    /**
     * Add item to IdentifierVehicleResult value
     * @throws \InvalidArgumentException
     * @param \StructType\IdentifierVehicleResult $item
     * @return \ArrayType\ArrayOfIdentifierVehicleResult
     */
    public function addToIdentifierVehicleResult(\StructType\IdentifierVehicleResult $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\IdentifierVehicleResult) {
            throw new \InvalidArgumentException(sprintf('The IdentifierVehicleResult property can only contain items of type \StructType\IdentifierVehicleResult, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->IdentifierVehicleResult[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\IdentifierVehicleResult|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\IdentifierVehicleResult|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\IdentifierVehicleResult|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\IdentifierVehicleResult|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\IdentifierVehicleResult|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string IdentifierVehicleResult
     */
    public function getAttributeName()
    {
        return 'IdentifierVehicleResult';
    }
}
